VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SR2D_Sprite"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Type GdiplusStartupInput
  GdiplusVersion As Long
  DebugEventCallback As Long
  SuppressBackgroundThread As Long
  SuppressExternalCodecs As Long
End Type

Private Type BitmapData
  Width As Long
  Height As Long
  Stride As Long
  PixelFormat As Long
  Scan0 As Long
  Reserved As Long
End Type

Private Type RECTL
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type

Private Type Point
  x As Long
  y As Long
End Type

Private Type CLSID
  Data1 As Long
  Data2 As Integer
  Data3 As Integer
  Data4(0 To 7) As Byte
End Type

Private Type EncoderParameter
  GUID As CLSID
  NumberOfValues As Long
  type As Long
  value As Long
End Type

Private Type EncoderParameters
  count As Long
  Parameter As EncoderParameter
End Type

Private Enum ImageLockMode
  ImageLockModeRead = &H1
  ImageLockModeWrite = &H2
  ImageLockModeUserInputBuf = &H4
End Enum

Private Const PixelFormat24bppRGB = &H21808
Private Const PixelFormat32bppARGB = &H26200A

Private Type BITMAPINFOHEADER
  biSize As Long
  biWidth As Long
  biHeight As Long
  biPlanes As Integer
  biBitCount As Integer
  biCompression As Long
  biSizeImage As Long
  biXPelsPerMeter As Double
  biClrUsed As Double
End Type

Private Type BITMAPINFO
  bmiHeader As BITMAPINFOHEADER
  bmiColors As Long
End Type

Private Declare Function GdiplusStartup Lib "gdiplus" (Token As Long, InputBuf As GdiplusStartupInput, Optional ByVal OutputBuf As Long = 0) As Long
Private Declare Function GdipCreateBitmapFromFile Lib "gdiplus" (ByVal pFileName As Long, Bitmap As Long) As Long
Private Declare Function GdipDisposeImage Lib "gdiplus" (ByVal Image As Long) As Long
Private Declare Sub GdiplusShutdown Lib "gdiplus" (ByVal Token As Long)
Private Declare Function GdipBitmapLockBits Lib "gdiplus" (ByVal Bitmap As Long, Rect As RECTL, ByVal Flags As ImageLockMode, ByVal PixelFormat As Long, lockedBitmapData As BitmapData) As Long
Private Declare Function GdipBitmapUnlockBits Lib "gdiplus" (ByVal Bitmap As Long, lockedBitmapData As BitmapData) As Long
Private Declare Function GdipGetImageWidth Lib "gdiplus" (ByVal Image As Long, Width As Long) As Long
Private Declare Function GdipGetImageHeight Lib "gdiplus" (ByVal Image As Long, Height As Long) As Long
Private Declare Function GdipCreateBitmapFromScan0 Lib "gdiplus" (ByVal Width As Long, ByVal Height As Long, ByVal Stride As Long, ByVal PixelFormat As Long, Scan0 As Any, Bitmap As Long) As Long
Private Declare Function GdipSaveImageToFile Lib "gdiplus" (ByVal Image As Long, ByVal pFileName As Long, clsidEncoder As CLSID, encoderParams As Any) As Long
Private Declare Function CLSIDFromString Lib "ole32" (ByVal lpszProgID As Long, pCLSID As CLSID) As Long

Private Declare Function SetDIBitsToDevice Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal dx As Long, ByVal dy As Long, ByVal SrcX As Long, ByVal SrcY As Long, ByVal Scan As Long, ByVal NumScans As Long, Bits As Any, BitsInfo As BITMAPINFO, ByVal wUsage As Long) As Long
Private Declare Function GetDIBits Lib "gdi32" (ByVal aHDC As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, lpBits As Any, lpBI As BITMAPINFO, ByVal wUsage As Long) As Long

Private Declare Sub CopyMemory Lib "SR2D" Alias "COPY_MEMORY" (ByRef Src As Any, ByRef Dest As Any, ByVal Length As Long)
Private Declare Sub SClearC Lib "SR2D" Alias "CLEAR_C" (ByRef Dest As Long, ByVal W As Long, ByVal h As Long, ByVal WD As Long, ByVal c As Long)
Private Declare Sub SMulAdd Lib "SR2D" Alias "V_MUL_ADD" (ByVal pSrc As Long, ByVal pDest As Long, ByVal W As Long, ByVal h As Long, ByVal WS As Long, ByVal WD As Long, ByVal VMul As Long, ByVal VAdd As Long)
Private Declare Sub SMaskMulAdd Lib "SR2D" Alias "MASK_V_MUL_ADD" (ByVal pSrc As Long, ByVal pDest As Long, ByVal pMask As Long, ByVal W As Long, ByVal h As Long, ByVal MaskEx As Long, ByVal WS As Long, ByVal WD As Long, ByVal WM As Long, ByVal NotMask As Long, ByVal VMul As Long, ByVal VAdd As Long)
Private Declare Sub SMaskClearC Lib "SR2D" Alias "MASK_CLEAR_C" (ByVal pDest As Long, ByVal pMask As Long, ByVal W As Long, ByVal h As Long, ByVal MaskEx As Long, ByVal WD As Long, ByVal WM As Long, ByVal c As Long, ByVal NotMask As Long)
Private Declare Function SMaskIS Lib "SR2D" Alias "MASK_INTERSECT" (ByVal pSrc As Long, ByVal pDest As Long, ByVal W As Long, ByVal h As Long, ByVal WS As Long, ByVal WD As Long, ByVal MaskEx As Long) As Long
Private Declare Sub SResize Lib "SR2D" Alias "RESIZE" (ByVal pSrc As Long, ByVal pDest As Long, ByVal WS As Long, ByVal HS As Long, ByVal WD As Long, ByVal HD As Long)
Private Declare Sub SFlipX Lib "SR2D" Alias "FLIP_X" (ByVal pSrc As Long, ByVal pDest As Long, ByVal W As Long, ByVal h As Long)
Private Declare Sub SFlipY Lib "SR2D" Alias "FLIP_Y" (ByVal pSrc As Long, ByVal pDest As Long, ByVal W As Long, ByVal h As Long)
Private Declare Sub SFlipXY Lib "SR2D" Alias "FLIP_XY" (ByVal pSrc As Long, ByVal pDest As Long, ByVal W As Long, ByVal h As Long)
Private Declare Sub SRotCW Lib "SR2D" Alias "ROT_CW" (ByVal pSrc As Long, ByVal pDest As Long, ByVal WS As Long, ByVal HS As Long)
Private Declare Sub SRotCCW Lib "SR2D" Alias "ROT_CCW" (ByVal pSrc As Long, ByVal pDest As Long, ByVal WS As Long, ByVal HS As Long)
Private Declare Sub SFlipXRotCCW Lib "SR2D" Alias "FLIP_X_ROT_CCW" (ByVal pSrc As Long, ByVal pDest As Long, ByVal WS As Long, ByVal HS As Long)
Private Declare Sub SFlipYRotCCW Lib "SR2D" Alias "FLIP_Y_ROT_CCW" (ByVal pSrc As Long, ByVal pDest As Long, ByVal WS As Long, ByVal HS As Long)
Private Declare Sub SDrawRot Lib "SR2D" Alias "DRAW_ROT" (ByVal pSrc As Long, ByVal pDest As Long, ByVal L As Long, ByVal T As Long, ByVal W As Long, ByVal h As Long, ByVal sx As Long, ByVal sy As Long, ByVal dx As Long, ByVal dy As Long, ByVal sw As Long, ByVal sh As Long, ByVal dw As Long, ByVal SinA As Long, ByVal CosA As Long)
Private Declare Sub SDrawRotAA Lib "SR2D" Alias "DRAW_ROT_AA" (ByVal pSrc As Long, ByVal pDest As Long, ByVal L As Long, ByVal T As Long, ByVal W As Long, ByVal h As Long, ByVal sx As Long, ByVal sy As Long, ByVal dx As Long, ByVal dy As Long, ByVal sw As Long, ByVal sh As Long, ByVal dw As Long, ByVal SinA As Long, ByVal CosA As Long)
Private Declare Sub SAddColorKey Lib "SR2D" Alias "ADD_COLOR_KEY" (ByRef Src As Long, ByVal W As Long, ByVal h As Long, ByVal cKey As Long)
Private Declare Sub Bpp32to24 Lib "SR2D" Alias "BPP_32TO24" (ByRef Src As Long, ByRef Dest As Byte, ByVal Width As Long, ByVal Height As Long, ByVal Stride As Long)
Private Declare Sub SDrawDotLine Lib "SR2D" Alias "DRAW_DOTLINE" (ByRef Dest As Long, ByVal W As Long, ByRef p1 As Point, ByRef p2 As Point, ByVal DotStep As Long, ByVal c As Long, ByVal IsXor As Long)
Private Declare Sub SClearA Lib "SR2D" Alias "CLR_ALPHA" (ByRef Dest As Long, ByVal Size As Long)

Private Declare Sub SPaint Lib "SR2D" Alias "PAINT" (ByVal pSrc As Long, ByVal pDest As Long, ByVal W As Long, ByVal h As Long, ByVal WS As Long, ByVal WD As Long)
Private Declare Sub SMul2X Lib "SR2D" Alias "MOD_2X" (ByVal pSrc As Long, ByVal pDest As Long, ByVal W As Long, ByVal h As Long, ByVal WS As Long, ByVal WD As Long)
Private Declare Sub SAdd2D Lib "SR2D" Alias "ADD_2D" (ByVal pSrc As Long, ByVal pDest As Long, ByVal W As Long, ByVal h As Long, ByVal WS As Long, ByVal WD As Long)
Private Declare Sub SAdd Lib "SR2D" Alias "ADD_" (ByVal pSrc As Long, ByVal pDest As Long, ByVal W As Long, ByVal h As Long, ByVal WS As Long, ByVal WD As Long)
Private Declare Sub SMul Lib "SR2D" Alias "MOD_" (ByVal pSrc As Long, ByVal pDest As Long, ByVal W As Long, ByVal h As Long, ByVal WS As Long, ByVal WD As Long)
Private Declare Sub SAlphaTest Lib "SR2D" Alias "ALPHA_T" (ByVal pSrc As Long, ByVal pDest As Long, ByVal W As Long, ByVal h As Long, ByVal WS As Long, ByVal WD As Long)
Private Declare Sub SAlphaBlend Lib "SR2D" Alias "ALPHA_B" (ByVal pSrc As Long, ByVal pDest As Long, ByVal W As Long, ByVal h As Long, ByVal WS As Long, ByVal WD As Long)
Private Declare Sub SMoveByte Lib "SR2D" Alias "MOVE_BYTE" (ByVal pSrc As Long, ByVal pDest As Long, ByVal W As Long, ByVal h As Long, ByVal WS As Long, ByVal WD As Long, ByVal MoveSrc As Long, ByVal MoveDest As Long)
Private Declare Sub SMoveBit Lib "SR2D" Alias "MOVE_BIT" (ByVal pSrc As Long, ByVal pDest As Long, ByVal W As Long, ByVal h As Long, ByVal WS As Long, ByVal WD As Long, ByVal MoveSrc As Long, ByVal MoveDest As Long)
Private Declare Sub SMax Lib "SR2D" Alias "MAX_" (ByVal pSrc As Long, ByVal pDest As Long, ByVal W As Long, ByVal h As Long, ByVal WS As Long, ByVal WD As Long)
Private Declare Sub SMin Lib "SR2D" Alias "MIN_" (ByVal pSrc As Long, ByVal pDest As Long, ByVal W As Long, ByVal h As Long, ByVal WS As Long, ByVal WD As Long)
Private Declare Sub SBlend Lib "SR2D" Alias "BLEND" (ByVal pSrc As Long, ByVal pDest As Long, ByVal W As Long, ByVal h As Long, ByVal WS As Long, ByVal WD As Long, ByVal k As Long)

Private Declare Sub SMaskPaint Lib "SR2D" Alias "MASK_PAINT" (ByVal pSrc As Long, ByVal pDest As Long, ByVal pMask As Long, ByVal W As Long, ByVal h As Long, ByVal MaskEx As Long, ByVal WS As Long, ByVal WD As Long, ByVal WM As Long, ByVal NotMask As Long)
Private Declare Sub SMaskMul2X Lib "SR2D" Alias "MASK_MOD_2X" (ByVal pSrc As Long, ByVal pDest As Long, ByVal pMask As Long, ByVal W As Long, ByVal h As Long, ByVal MaskEx As Long, ByVal WS As Long, ByVal WD As Long, ByVal WM As Long, ByVal NotMask As Long)
Private Declare Sub SMaskAdd2D Lib "SR2D" Alias "MASK_ADD_2D" (ByVal pSrc As Long, ByVal pDest As Long, ByVal pMask As Long, ByVal W As Long, ByVal h As Long, ByVal MaskEx As Long, ByVal WS As Long, ByVal WD As Long, ByVal WM As Long, ByVal NotMask As Long)
Private Declare Sub SMaskAdd Lib "SR2D" Alias "MASK_ADD" (ByVal pSrc As Long, ByVal pDest As Long, ByVal pMask As Long, ByVal W As Long, ByVal h As Long, ByVal MaskEx As Long, ByVal WS As Long, ByVal WD As Long, ByVal WM As Long, ByVal NotMask As Long)
Private Declare Sub SMaskMul Lib "SR2D" Alias "MASK_MOD" (ByVal pSrc As Long, ByVal pDest As Long, ByVal pMask As Long, ByVal W As Long, ByVal h As Long, ByVal MaskEx As Long, ByVal WS As Long, ByVal WD As Long, ByVal WM As Long, ByVal NotMask As Long)
Private Declare Sub SMaskAlphaTest Lib "SR2D" Alias "MASK_ALPHA_T" (ByVal pSrc As Long, ByVal pDest As Long, ByVal pMask As Long, ByVal W As Long, ByVal h As Long, ByVal MaskEx As Long, ByVal WS As Long, ByVal WD As Long, ByVal WM As Long, ByVal NotMask As Long)
Private Declare Sub SMaskAlphaBlend Lib "SR2D" Alias "MASK_ALPHA_B" (ByVal pSrc As Long, ByVal pDest As Long, ByVal pMask As Long, ByVal W As Long, ByVal h As Long, ByVal MaskEx As Long, ByVal WS As Long, ByVal WD As Long, ByVal WM As Long, ByVal NotMask As Long)
Private Declare Sub SMaskMoveByte Lib "SR2D" Alias "MASK_MOVE_BYTE" (ByVal pSrc As Long, ByVal pDest As Long, ByVal pMask As Long, ByVal W As Long, ByVal h As Long, ByVal MaskEx As Long, ByVal WS As Long, ByVal WD As Long, ByVal WM As Long, ByVal NotMask As Long, ByVal MoveSrc As Long, ByVal MoveDest As Long)
Private Declare Sub SMaskMoveBit Lib "SR2D" Alias "MASK_MOVE_BIT" (ByVal pSrc As Long, ByVal pDest As Long, ByVal pMask As Long, ByVal W As Long, ByVal h As Long, ByVal MaskEx As Long, ByVal WS As Long, ByVal WD As Long, ByVal WM As Long, ByVal NotMask As Long, ByVal MoveSrc As Long, ByVal MoveDest As Long)
Private Declare Sub SMaskMax Lib "SR2D" Alias "MASK_MAX" (ByVal pSrc As Long, ByVal pDest As Long, ByVal pMask As Long, ByVal W As Long, ByVal h As Long, ByVal MaskEx As Long, ByVal WS As Long, ByVal WD As Long, ByVal WM As Long, ByVal NotMask As Long)
Private Declare Sub SMaskMin Lib "SR2D" Alias "MASK_MIN" (ByVal pSrc As Long, ByVal pDest As Long, ByVal pMask As Long, ByVal W As Long, ByVal h As Long, ByVal MaskEx As Long, ByVal WS As Long, ByVal WD As Long, ByVal WM As Long, ByVal NotMask As Long)
Private Declare Sub SMaskBlend Lib "SR2D" Alias "MASK_BLEND" (ByVal pSrc As Long, ByVal pDest As Long, ByVal pMask As Long, ByVal W As Long, ByVal h As Long, ByVal MaskEx As Long, ByVal WS As Long, ByVal WD As Long, ByVal WM As Long, ByVal NotMask As Long, ByVal k As Long)

Private Declare Sub SDrawEBM Lib "SR2D" Alias "EBM_" (ByVal pBMap As Long, ByVal pDest As Long, ByVal pLMap As Long, ByVal W As Long, ByVal h As Long, ByVal WB As Long, ByVal WD As Long, ByVal WL As Long, ByVal HL As Long)
Private Declare Sub SDrawEBMEx Lib "SR2D" Alias "EBM_EX" (ByVal pBMap As Long, ByVal pDest As Long, ByVal pLMap As Long, ByVal W As Long, ByVal h As Long, ByVal WB As Long, ByVal WD As Long, ByVal WL As Long, ByVal HL As Long, ByVal xx As Long, ByVal yy As Long, ByVal HD As Long)
Private Declare Sub SDrawDPBM Lib "SR2D" Alias "DPBM_" (ByVal pBMap As Long, ByVal pDest As Long, ByVal W As Long, ByVal h As Long, ByVal c As Long, ByVal WS As Long, ByVal WD As Long)
Private Declare Sub SDrawDPBMPoint Lib "SR2D" Alias "DPBM_POINT" (ByVal pSrc As Long, ByVal pDest As Long, ByVal W As Long, ByVal h As Long, ByVal WS As Long, ByVal WD As Long, ByVal Lx As Long, ByVal Ly As Long, ByVal Lz As Long, ByVal Br As Long)
Private Declare Sub SMaskDrawDPBMPoint Lib "SR2D" Alias "MASK_DPBM_POINT" (ByVal pSrc As Long, ByVal pDest As Long, ByVal pMask As Long, ByVal MaskEx As Long, ByVal W As Long, ByVal h As Long, ByVal WS As Long, ByVal WD As Long, ByVal WM As Long, ByVal Lx As Long, ByVal Ly As Long, ByVal Lz As Long, ByVal Br As Long, ByVal NotMask As Long)
Private Declare Sub SMaskDrawDPBM Lib "SR2D" Alias "MASK_DPBM" (ByVal pSrc As Long, ByVal pDest As Long, ByVal pMask As Long, ByVal W As Long, ByVal h As Long, ByVal c As Long, ByVal MaskEx As Long, ByVal WS As Long, ByVal WD As Long, ByVal WM As Long, ByVal NotMask As Long)
Private Declare Sub SMaskDrawEBM Lib "SR2D" Alias "MASK_EBM" (ByVal pSrc As Long, ByVal pDest As Long, ByVal pMask As Long, ByVal pLMap As Long, ByVal MaskEx As Long, ByVal W As Long, ByVal h As Long, ByVal WS As Long, ByVal WD As Long, ByVal WM As Long, ByVal WL As Long, ByVal HL As Long, ByVal NotMask As Long)
Private Declare Sub SMaskDrawEBMEx Lib "SR2D" Alias "MASK_EBM_EX" (ByVal pSrc As Long, ByVal pDest As Long, ByVal pMask As Long, ByVal pLMap As Long, ByVal MaskEx As Long, ByVal W As Long, ByVal h As Long, ByVal WS As Long, ByVal WD As Long, ByVal WM As Long, ByVal WL As Long, ByVal HL As Long, ByVal NotMask As Long, ByVal xx As Long, ByVal yy As Long, ByVal HD As Long)

Dim meWidth As Long, meHeight As Long, meOp As SR2D_Op
Dim meLeft As Long, meRight As Long, meTop As Long, meBottom As Long
Dim cBuf() As Long
Dim meBFactor As Long
Dim bi32BitInfo As BITMAPINFO

Public Sub DrawLine(ByVal lx1 As Long, ByVal ly1 As Long, ByVal lx2 As Long, ByVal ly2 As Long, ByVal c As Long, Optional ByVal DotStep As Long = 0, Optional ByVal IsXor As Boolean = False)
  Dim p1 As Point, p2 As Point
  Dim L As Long, R As Long, T As Long, B As Long
  Dim k As Single

  p1.x = lx1
  p1.y = ly1
  p2.x = lx2
  p2.y = ly2
  L = meLeft
  R = meRight - 1
  T = meTop
  B = meBottom - 1

  If p1.y > p2.y Then SwapPoints p1, p2
  If p1.y > B Then Exit Sub
  If p2.y < T Then Exit Sub
  If p1.y <> p2.y Then
    If p1.y < T Or p2.y > B Then
      k = (p2.x - p1.x) / (p2.y - p1.y)
      If p1.y < T Then
        p1.x = p2.x + (T - p2.y) * k
        p1.y = T
      End If
      If p2.y > B Then
        p2.x = p1.x + (B - p1.y) * k
        p2.y = B
      End If
    End If
  End If

  If p1.x > p2.x Then SwapPoints p1, p2
  If p1.x > R Then Exit Sub
  If p2.x < L Then Exit Sub
  If p1.x <> p2.x Then
    If p1.x < L Or p2.x > R Then
      k = (p2.y - p1.y) / (p2.x - p1.x)
      If p1.x < L Then
        p1.y = p2.y + (L - p2.x) * k
        p1.x = L
      End If
      If p2.x > R Then
        p2.y = p1.y + (R - p1.x) * k
        p2.x = R
      End If
    End If
  End If

  SDrawDotLine cBuf(0), meWidth, p1, p2, (DotStep And 65535) + 1, c, IsXor
End Sub

Private Sub SwapPoints(p1 As Point, p2 As Point)
  Dim p As Point

  p = p1
  p1 = p2
  p2 = p
End Sub

Private Function TransformCoordAbs(ByVal L2 As Long, ByVal R2 As Long, ByVal T2 As Long, ByVal b2 As Long, _
                  ByVal W2 As Long, W As Long, h As Long, p1 As Long, p2 As Long) As Boolean
  Dim L As Long, R As Long, T As Long, B As Long

  If 0 >= L2 Then
    L = 0
  Else
    L = L2
  End If
  If meWidth <= R2 Then
    R = meWidth
  Else
    R = R2
  End If
  If 0 >= T2 Then
    T = 0
  Else
    T = T2
  End If
  If meHeight <= b2 Then
    B = meHeight
  Else
    B = b2
  End If
  If L >= R Then Exit Function
  If T >= B Then Exit Function

  TransformCoordAbs = True
  W = R - L
  h = B - T

  p1 = (T * meWidth + L) * 4
  p2 = ((T - T2) * W2 + L - L2) * 4
End Function

Private Function TransformCoord2(ByVal L2 As Long, ByVal R2 As Long, ByVal T2 As Long, ByVal b2 As Long, _
                  ByVal W2 As Long, W As Long, h As Long, p1 As Long, p2 As Long) As Boolean
  Dim L As Long, R As Long, T As Long, B As Long

  If meLeft >= L2 Then
    L = meLeft
  Else
    L = L2
  End If
  If meRight <= R2 Then
    R = meRight
  Else
    R = R2
  End If
  If meTop >= T2 Then
    T = meTop
  Else
    T = T2
  End If
  If meBottom <= b2 Then
    B = meBottom
  Else
    B = b2
  End If
  If L >= R Then Exit Function
  If T >= B Then Exit Function

  TransformCoord2 = True
  W = R - L
  h = B - T

  p1 = ((T - meTop) * meWidth + L - meLeft) * 4
  p2 = ((T - T2) * W2 + L - L2) * 4
End Function

Private Function TransformCoord3(ByVal L2 As Long, ByVal R2 As Long, ByVal T2 As Long, ByVal b2 As Long, _
                  ByVal L3 As Long, ByVal R3 As Long, ByVal T3 As Long, ByVal b3 As Long, _
                  ByVal W2 As Long, ByVal W3 As Long, W As Long, h As Long, p1 As Long, p2 As Long, P3 As Long) As Boolean
  Dim L As Long, R As Long, T As Long, B As Long

  If meLeft >= L2 Then
    L = meLeft
  Else
    L = L2
  End If
  If L < L3 Then L = L3
  If meRight <= R2 Then
    R = meRight
  Else
    R = R2
  End If
  If R > R3 Then R = R3
  If meTop >= T2 Then
    T = meTop
  Else
    T = T2
  End If
  If T < T3 Then T = T3
  If meBottom <= b2 Then
    B = meBottom
  Else
    B = b2
  End If
  If B > b3 Then B = b3
  If L >= R Then Exit Function
  If T >= B Then Exit Function

  TransformCoord3 = True
  W = R - L
  h = B - T

  p1 = ((T - meTop) * meWidth + L - meLeft) * 4
  p2 = ((T - T2) * W2 + L - L2) * 4
  P3 = ((T - T3) * W3 + L - L3) * 4
End Function

Public Sub ClearBuffer(ByVal c As Long)
  If meRight <= meLeft Then Exit Sub
  If meBottom <= meTop Then Exit Sub
  SClearC cBuf(meLeft + meTop * meWidth), meRight - meLeft, meBottom - meTop, meWidth, c
End Sub

Public Sub MaskClearBuffer(SrcMask As SR2D_Sprite, ByVal Mx As Long, ByVal My As Long, ByVal c As Long, ByVal Mask As Long, Optional ByVal NotMask As Boolean = False)
  Dim W As Long, h As Long, Mp As Long, Dp As Long

  If Not TransformCoord2(Mx, Mx + SrcMask.Width, My, My + SrcMask.Height, SrcMask.Width, W, h, Dp, Mp) Then Exit Sub
  
  Dp = Dp + DataPTR(meLeft, meTop)
  Mp = Mp + SrcMask.DataPTR(0, 0)
  
  SMaskClearC Dp, Mp, W, h, Mask, meWidth, SrcMask.Width, c, NotMask
End Sub

Public Sub ClearRect(ByVal Left As Long, ByVal Right As Long, ByVal Top As Long, ByVal Bottom As Long, ByVal c As Long)
  If Left < meLeft Then Left = meLeft
  If Right > meRight Then Right = meRight
  If Right <= Left Then Exit Sub
  If Top < meTop Then Top = meTop
  If Bottom > meBottom Then Bottom = meBottom
  If Bottom <= Top Then Exit Sub
  SClearC cBuf(Left + Top * meWidth), Right - Left, Bottom - Top, meWidth, c
End Sub

Public Sub DrawRotate(Src As SR2D_Sprite, ByVal sx As Long, ByVal sy As Long, ByVal dx As Long, ByVal dy As Long, ByVal Angle As Single, Optional ByVal AA As Boolean = False)
  Dim sw As Long, sh As Long
  Dim ddx As Long, ddy As Long
  Dim SinA As Long, CosA As Long
  Dim L As Long, R As Long, T As Long, B As Long
  Dim x As Long, y As Long, v As Long

  If meRight <= meLeft Then Exit Sub
  If meBottom <= meTop Then Exit Sub
  sw = Src.Width
  sh = Src.Height
  ddx = dx * &H10000 + &H8000&
  ddy = dy * &H10000 + &H8000&
  SinA = Sin(Angle) * &H10000
  CosA = Cos(Angle) * &H10000

  L = ddx - sx * CosA - sy * SinA
  R = L
  x = ddx - (sx - sw) * CosA - sy * SinA
  If L > x Then L = x
  If R < x Then R = x
  x = ddx - sx * CosA - (sy - sh) * SinA
  If L > x Then L = x
  If R < x Then R = x
  x = ddx - (sx - sw) * CosA - (sy - sh) * SinA
  If L > x Then L = x
  If R < x Then R = x

  T = ddy - sy * CosA + sx * SinA
  B = T
  y = ddy - (sy - sh) * CosA + sx * SinA
  If T > y Then T = y
  If B < y Then B = y
  y = ddy - sy * CosA + (sx - sw) * SinA
  If T > y Then T = y
  If B < y Then B = y
  y = ddy - (sy - sh) * CosA + (sx - sw) * SinA
  If T > y Then T = y
  If B < y Then B = y

  L = L \ &H10000
  If L < meLeft Then L = meLeft
  T = T \ &H10000
  If T < meTop Then T = meTop
  R = R \ &H10000
  If R >= meRight Then R = meRight Else R = R + 1
  B = B \ &H10000
  If B >= meBottom Then B = meBottom Else B = B + 1
  If AA Then
    SDrawRotAA Src.DataPTR(0, 0), VarPtr(cBuf(0)), L, T, R, B, sx, sy, dx, dy, sw, sh, meWidth, SinA, CosA
  Else
    SDrawRot Src.DataPTR(0, 0), VarPtr(cBuf(0)), L, T, R, B, sx, sy, dx, dy, sw, sh, meWidth, SinA, CosA
  End If
End Sub

Public Sub DrawDPBM(Src As SR2D_Sprite, ByVal sx As Long, ByVal sy As Long, ByVal Lx As Long, ByVal Ly As Long, ByVal Lz As Long, Optional ByVal Brite As Single = 1, Optional ByVal PointLite As Boolean = False)
  Dim W As Long, h As Long, Sp As Long, Dp As Long

  If Not TransformCoord2(sx, sx + Src.Width, sy, sy + Src.Height, Src.Width, W, h, Dp, Sp) Then Exit Sub

  Dp = Dp + DataPTR(meLeft, meTop)
  Sp = Sp + Src.DataPTR(0, 0)

  If PointLite Then
    If meLeft < sx Then Lx = Lx - sx Else Lx = Lx - meLeft
    If meTop < sy Then Ly = Ly - sy Else Ly = Ly - meTop
    If Brite < -2 Then
      Brite = -2
    ElseIf Brite > 2 Then
      Brite = 2
    End If
    SDrawDPBMPoint Sp, Dp, W, h, Src.Width, meWidth, Lx, Ly, Lz, Brite * &H100000
  Else
    SDrawDPBM Sp, Dp, W, h, ColFromLite(Lx, Ly, Lz, Brite), Src.Width, meWidth
  End If
End Sub

Public Sub MaskDrawDPBM(Src As SR2D_Sprite, SrcMask As SR2D_Sprite, ByVal sx As Long, ByVal sy As Long, ByVal Mx As Long, ByVal My As Long, ByVal Mask As Long, ByVal Lx As Long, ByVal Ly As Long, ByVal Lz As Long, Optional ByVal Brite As Single = 1, Optional ByVal NotMask As Boolean = False, Optional ByVal PointLite As Boolean = False)
  Dim W As Long, h As Long, Sp As Long, Dp As Long, Mp As Long

  If Not TransformCoord3(sx, sx + Src.Width, sy, sy + Src.Height, Mx, Mx + SrcMask.Width, My, My + SrcMask.Height, Src.Width, SrcMask.Width, W, h, Dp, Sp, Mp) Then Exit Sub

  Dp = Dp + DataPTR(0, 0)
  Sp = Sp + Src.DataPTR(0, 0)
  Mp = Mp + SrcMask.DataPTR(0, 0)

  If PointLite Then
    If meLeft < sx Then
      If Mx < sx Then
        Lx = Lx - sx
      Else
        Lx = Lx - Mx
      End If
    Else
      If Mx < meLeft Then
        Lx = Lx - meLeft
      Else
        Lx = Lx - Mx
      End If
    End If
  
    If meTop < sy Then
      If My < sy Then
        Ly = Ly - sy
      Else
        Ly = Ly - My
      End If
    Else
      If My < meTop Then
        Ly = Ly - meTop
      Else
        Ly = Ly - My
      End If
    End If
  
    If Brite < -2 Then
      Brite = -2
    ElseIf Brite > 2 Then
      Brite = 2
    End If
    SMaskDrawDPBMPoint Sp, Dp, Mp, Mask, W, h, Src.Width, meWidth, SrcMask.Width, Lx, Ly, Lz, Brite * &H100000, NotMask
  Else
    SMaskDrawDPBM Sp, Dp, Mp, W, h, ColFromLite(Lx, Ly, Lz, Brite), Mask, Src.Width, meWidth, SrcMask.Width, NotMask
  End If
End Sub

Public Sub Draw(Src As SR2D_Sprite, ByVal sx As Long, ByVal sy As Long, Optional ByVal Op As SR2D_Op = OpDefault)
  Dim W As Long, h As Long, Sp As Long, Dp As Long

  If Not TransformCoord2(sx, sx + Src.Width, sy, sy + Src.Height, Src.Width, W, h, Dp, Sp) Then Exit Sub

  Dp = Dp + DataPTR(meLeft, meTop)
  Sp = Sp + Src.DataPTR(0, 0)

  If Op = OpDefault Then Op = Src.Op
  Select Case Op
    Case OpPaint
      SPaint Sp, Dp, W, h, Src.Width, meWidth
    Case OpAlphaTest
      SAlphaTest Sp, Dp, W, h, Src.Width, meWidth
    Case OpAlphaBlend
      SAlphaBlend Sp, Dp, W, h, Src.Width, meWidth
    Case OpAdd2D
      SAdd2D Sp, Dp, W, h, Src.Width, meWidth
    Case OpAdd
      SAdd Sp, Dp, W, h, Src.Width, meWidth
    Case OpMul2X
      SMul2X Sp, Dp, W, h, Src.Width, meWidth
    Case OpMul
      SMul Sp, Dp, W, h, Src.Width, meWidth
    Case OpBlend
      SBlend Sp, Dp, W, h, Src.Width, meWidth, Src.BlendFactor
    Case OpMax
      SMax Sp, Dp, W, h, Src.Width, meWidth
    Case OpMin
      SMin Sp, Dp, W, h, Src.Width, meWidth
  End Select
End Sub

Public Sub MaskDraw(Src As SR2D_Sprite, SrcMask As SR2D_Sprite, ByVal sx As Long, ByVal sy As Long, ByVal Mx As Long, ByVal My As Long, ByVal Mask As Long, Optional ByVal NotMask As Boolean = False, Optional ByVal Op As SR2D_Op = OpDefault)
  Dim W As Long, h As Long, Sp As Long, Dp As Long, Mp As Long

  If Not TransformCoord3(sx, sx + Src.Width, sy, sy + Src.Height, Mx, Mx + SrcMask.Width, My, My + SrcMask.Height, Src.Width, SrcMask.Width, W, h, Dp, Sp, Mp) Then Exit Sub

  Dp = Dp + DataPTR(0, 0)
  Sp = Sp + Src.DataPTR(0, 0)
  Mp = Mp + SrcMask.DataPTR(0, 0)

  If Op = OpDefault Then Op = Src.Op
  Select Case Op
    Case OpPaint
      SMaskPaint Sp, Dp, Mp, W, h, Mask, Src.Width, meWidth, SrcMask.Width, NotMask
    Case OpMul2X
      SMaskMul2X Sp, Dp, Mp, W, h, Mask, Src.Width, meWidth, SrcMask.Width, NotMask
    Case OpAdd2D
      SMaskAdd2D Sp, Dp, Mp, W, h, Mask, Src.Width, meWidth, SrcMask.Width, NotMask
    Case OpAdd
      SMaskAdd Sp, Dp, Mp, W, h, Mask, Src.Width, meWidth, SrcMask.Width, NotMask
    Case OpMul
      SMaskMul Sp, Dp, Mp, W, h, Mask, Src.Width, meWidth, SrcMask.Width, NotMask
    Case OpBlend
      SMaskBlend Sp, Dp, Mp, W, h, Mask, Src.Width, meWidth, SrcMask.Width, NotMask, Src.BlendFactor
    Case OpAlphaTest
      SMaskAlphaTest Sp, Dp, Mp, W, h, Mask, Src.Width, meWidth, SrcMask.Width, NotMask
    Case OpAlphaBlend
      SMaskAlphaBlend Sp, Dp, Mp, W, h, Mask, Src.Width, meWidth, SrcMask.Width, NotMask
    Case OpMax
      SMaskMax Sp, Dp, Mp, W, h, Mask, Src.Width, meWidth, SrcMask.Width, NotMask
    Case OpMin
      SMaskMin Sp, Dp, Mp, W, h, Mask, Src.Width, meWidth, SrcMask.Width, NotMask
  End Select
End Sub

Public Function MaskInterSector(Src As SR2D_Sprite, ByVal sx As Long, ByVal sy As Long, ByVal Mask As Long) As Long
  Dim W As Long, h As Long, Sp As Long, Dp As Long

  If Not TransformCoordAbs(sx, sx + Src.Width, sy, sy + Src.Height, Src.Width, W, h, Dp, Sp) Then Exit Function

  Dp = Dp + DataPTR(0, 0)
  Sp = Sp + Src.DataPTR(0, 0)

  MaskInterSector = SMaskIS(Sp, Dp, W, h, Src.Width, meWidth, Mask)
End Function

Public Sub DrawEBM(SRCBump As SR2D_Sprite, SRCCol As SR2D_Sprite, ByVal sx As Long, ByVal sy As Long, Optional ByVal DestSpace As Boolean = False)
  Dim W As Long, h As Long, Dp As Long, Sp As Long, Cp As Long

  If Not TransformCoord2(sx, sx + SRCBump.Width, sy, sy + SRCBump.Height, SRCBump.Width, W, h, Dp, Sp) Then Exit Sub

  Dp = Dp + DataPTR(0, 0)
  Sp = Sp + SRCBump.DataPTR(0, 0)
  Cp = SRCCol.DataPTR(0, 0)

  If DestSpace Then
    If sx < 0 Then sx = 0
    If sy < 0 Then sy = 0
    SDrawEBMEx Sp, Dp, Cp, W, h, SRCBump.Width, meWidth, SRCCol.Width, SRCCol.Height, sx, sy, meHeight
  Else
    SDrawEBM Sp, Dp, Cp, W, h, SRCBump.Width, meWidth, SRCCol.Width, SRCCol.Height
  End If
End Sub

Public Sub MaskDrawEBM(SRCBump As SR2D_Sprite, SrcMask As SR2D_Sprite, SRCCol As SR2D_Sprite, ByVal sx As Long, ByVal sy As Long, ByVal Mx As Long, ByVal My As Long, ByVal Mask As Long, Optional ByVal NotMask As Boolean = False, Optional ByVal DestSpace As Boolean = False)
  Dim W As Long, h As Long, Dp As Long, Sp As Long, Mp As Long, Cp As Long

  If Not TransformCoord3(sx, sx + SRCBump.Width, sy, sy + SRCBump.Height, Mx, Mx + SrcMask.Width, My, My + SrcMask.Height, SRCBump.Width, SrcMask.Width, W, h, Dp, Sp, Mp) Then Exit Sub

  Dp = Dp + DataPTR(0, 0)
  Sp = Sp + SRCBump.DataPTR(0, 0)
  Mp = Mp + SrcMask.DataPTR(0, 0)
  Cp = SRCCol.DataPTR(0, 0)

  If DestSpace Then
    If sx < 0 Then sx = 0
    If sy < 0 Then sy = 0
    SMaskDrawEBMEx Sp, Dp, Mp, Cp, Mask, W, h, SRCBump.Width, meWidth, SrcMask.Width, SRCCol.Width, SRCCol.Height, NotMask, sx, sy, meHeight
  Else
    SMaskDrawEBM Sp, Dp, Mp, Cp, Mask, W, h, SRCBump.Width, meWidth, SrcMask.Width, SRCCol.Width, SRCCol.Height, NotMask
  End If
End Sub

Public Sub MulAddS2X(Src As SR2D_Sprite, ByVal sx As Long, ByVal sy As Long, ByVal Mul As Long, ByVal Add As Long)
  Dim W As Long, h As Long, Sp As Long, Dp As Long

  If Not TransformCoord2(sx, sx + Src.Width, sy, sy + Src.Height, Src.Width, W, h, Dp, Sp) Then Exit Sub

  Dp = Dp + DataPTR(meLeft, meTop)
  Sp = Sp + Src.DataPTR(0, 0)

  SMulAdd Sp, Dp, W, h, Src.Width, meWidth, Mul, Add
End Sub

Public Sub MaskMulAddS2X(Src As SR2D_Sprite, SrcMask As SR2D_Sprite, ByVal sx As Long, ByVal sy As Long, ByVal Mx As Long, ByVal My As Long, ByVal Mul As Long, ByVal Add As Long, ByVal Mask As Long, Optional ByVal NotMask As Boolean = False)
  Dim W As Long, h As Long, Sp As Long, Dp As Long, Mp As Long

  If Not TransformCoord3(sx, sx + Src.Width, sy, sy + Src.Height, Mx, Mx + SrcMask.Width, My, My + SrcMask.Height, Src.Width, SrcMask.Width, W, h, Dp, Sp, Mp) Then Exit Sub

  Dp = Dp + DataPTR(0, 0)
  Sp = Sp + Src.DataPTR(0, 0)
  Mp = Mp + SrcMask.DataPTR(0, 0)

  SMaskMulAdd Sp, Dp, Mp, W, h, Mask, Src.Width, meWidth, SrcMask.Width, -NotMask, Mul, Add
End Sub

Public Sub MoveByte(Src As SR2D_Sprite, ByVal sx As Long, ByVal sy As Long, ByVal chSrc As SR2D_ColChannel, ByVal chDest As SR2D_ColChannel)
  Dim W As Long, h As Long, Sp As Long, Dp As Long

  If Not TransformCoord2(sx, sx + Src.Width, sy, sy + Src.Height, Src.Width, W, h, Dp, Sp) Then Exit Sub

  Dp = Dp + DataPTR(meLeft, meTop)
  Sp = Sp + Src.DataPTR(0, 0)

  SMoveByte Sp, Dp, W, h, Src.Width, meWidth, chSrc, chDest
End Sub

Public Sub MoveBit(Src As SR2D_Sprite, ByVal sx As Long, ByVal sy As Long, ByVal mbSrc As Long, ByVal mbDest As Long)
  Dim W As Long, h As Long, Sp As Long, Dp As Long

  If Not TransformCoord2(sx, sx + Src.Width, sy, sy + Src.Height, Src.Width, W, h, Dp, Sp) Then Exit Sub

  Dp = Dp + DataPTR(meLeft, meTop)
  Sp = Sp + Src.DataPTR(0, 0)

  SMoveBit Sp, Dp, W, h, Src.Width, meWidth, mbSrc, mbDest
End Sub

Public Sub MaskMoveByte(Src As SR2D_Sprite, SrcMask As SR2D_Sprite, ByVal sx As Long, ByVal sy As Long, ByVal Mx As Long, ByVal My As Long, ByVal chSrc As SR2D_ColChannel, ByVal chDest As SR2D_ColChannel, ByVal Mask As Long, Optional ByVal NotMask As Boolean = False)
  Dim W As Long, h As Long, Sp As Long, Dp As Long, Mp As Long

  If Not TransformCoord3(sx, sx + Src.Width, sy, sy + Src.Height, Mx, Mx + SrcMask.Width, My, My + SrcMask.Height, Src.Width, SrcMask.Width, W, h, Dp, Sp, Mp) Then Exit Sub

  Dp = Dp + DataPTR(0, 0)
  Sp = Sp + Src.DataPTR(0, 0)
  Mp = Mp + SrcMask.DataPTR(0, 0)

  SMaskMoveByte Sp, Dp, Mp, W, h, Mask, Src.Width, meWidth, SrcMask.Width, -NotMask, chSrc, chDest
End Sub

Public Sub MaskMoveBit(Src As SR2D_Sprite, SrcMask As SR2D_Sprite, ByVal sx As Long, ByVal sy As Long, ByVal Mx As Long, ByVal My As Long, ByVal mbSrc As Long, ByVal mbDest As Long, ByVal Mask As Long, Optional ByVal NotMask As Boolean = False)
  Dim W As Long, h As Long, Sp As Long, Dp As Long, Mp As Long

  If Not TransformCoord3(sx, sx + Src.Width, sy, sy + Src.Height, Mx, Mx + SrcMask.Width, My, My + SrcMask.Height, Src.Width, SrcMask.Width, W, h, Dp, Sp, Mp) Then Exit Sub

  Dp = Dp + DataPTR(0, 0)
  Sp = Sp + Src.DataPTR(0, 0)
  Mp = Mp + SrcMask.DataPTR(0, 0)

  SMaskMoveBit Sp, Dp, Mp, W, h, Mask, Src.Width, meWidth, SrcMask.Width, -NotMask, mbSrc, mbDest
End Sub

Public Sub TileDraw(Src As SR2D_Sprite, ByVal dx As Long, ByVal dy As Long, ByVal W As Long, ByVal h As Long, Optional ByVal sx As Long = 0, Optional ByVal sy As Long = 0, Optional ByVal Op As SR2D_Op = OpDefault)
  Dim meL As Long, meR As Long, meT As Long, meB As Long
  Dim x As Long, y As Long, sw As Long, sh As Long

  meL = meLeft
  meR = meRight
  meT = meTop
  meB = meBottom

  Do
    If dx > meLeft Then If dx < meRight Then meLeft = dx Else Exit Do
    If dy > meTop Then If dy < meBottom Then meTop = dy Else Exit Do
    If dx + W <= meLeft Then Exit Do Else If dx + W < meRight Then meRight = dx + W
    If dy + h <= meTop Then Exit Do Else If dy + h < meBottom Then meBottom = dy + h
    sh = Src.Height
    sw = Src.Width
    sx = sx - Int((sx + sw) / sw) * sw
    sy = sy - Int((sy + sh) / sh) * sh
    For y = dy + sy To meBottom - 1 Step sh
      For x = dx + sx To meRight - 1 Step sw
        Draw Src, x, y, Op
      Next x
    Next y
  Loop While False

  meLeft = meL
  meRight = meR
  meTop = meT
  meBottom = meB
End Sub

Public Sub Init(Optional ByVal W As Long = 0, Optional ByVal h As Long = 0, Optional ByVal Op As SR2D_Op = OpDefault)
  If Op <> OpDefault Then meOp = Op
  If W <= 0 And h <= 0 Then Exit Sub
  If W = meWidth And h = meHeight Then Exit Sub
  If W > 0 Then meWidth = W
  If h > 0 Then meHeight = h
  SetLockRect 0, meWidth, 0, meHeight
  ReDim cBuf(meWidth * meHeight - 1) As Long
  With bi32BitInfo.bmiHeader
    .biBitCount = 32
    .biPlanes = 1
    .biSize = Len(bi32BitInfo.bmiHeader)
    .biWidth = meWidth
    .biHeight = -meHeight
    .biSizeImage = 4 * (meWidth * meHeight)
  End With
End Sub

Public Sub LoadFromIPicture(Src As IPicture, ByVal hdc As Long, Optional ByVal Trans As SR2D_Transform = TrNone, Optional ByVal W As Long = 0, Optional ByVal h As Long = 0, Optional ByVal cKey As Long = -1)
  Dim oW As Long, oH As Long
  Dim Sp As SR2D_Sprite

  oW = Src.Width * 0.5669292 / Screen.TwipsPerPixelX
  oH = Src.Height * 0.5669292 / Screen.TwipsPerPixelY

  If Trans <> TrNone Or W > 0 Or h > 0 Then
    Set Sp = New SR2D_Sprite
    Sp.LoadFromIPicture Src, hdc
    LoadFromSprite Sp, Trans, W, h
  Else
    Init oW, oH, OpPaint
    GetDIBits hdc, Src.Handle, 0, meHeight, cBuf(0), bi32BitInfo, 0
    SClearA cBuf(0), meWidth * meHeight
  End If
  If cKey >= 0 Then AddColorKey cKey: Op = OpAlphaTest
End Sub

Public Sub LoadFromFile(fName As String, Optional ByVal Trans As SR2D_Transform = TrNone, Optional ByVal W As Long = 0, Optional ByVal h As Long = 0, Optional ByVal cKey As Long = -1)
  Dim Res As Long
  Dim tSI As GdiplusStartupInput
  Dim GDIP As Long
  Dim Bmp As Long
  Dim lData As BitmapData
  Dim R As RECTL
  Dim x As Long, y As Long
  Dim Sp As SR2D_Sprite

  If Trans <> TrNone Or W > 0 Or h > 0 Then
    Set Sp = New SR2D_Sprite
    Sp.LoadFromFile fName
    LoadFromSprite Sp, Trans, W, h, cKey
  Else
    tSI.GdiplusVersion = 1
    Res = GdiplusStartup(GDIP, tSI)
    If Res = 0 Then
      Res = GdipCreateBitmapFromFile(StrPtr(fName), Bmp)
      If Res = 0 Then
        GdipGetImageWidth Bmp, x
        GdipGetImageHeight Bmp, y
        R.Left = 0
        R.Right = x
        R.Top = 0
        R.Bottom = y
        Res = GdipBitmapLockBits(Bmp, R, ImageLockModeRead, PixelFormat32bppARGB, lData)
        If Res = 0 Then
          Init x, y, OpPaint
          CopyMemory ByVal lData.Scan0, cBuf(0), x * y * 4
          GdipBitmapUnlockBits Bmp, lData
          If cKey >= 0 Then AddColorKey cKey: Op = OpAlphaTest
        End If
        GdipDisposeImage Bmp
      End If
      GdiplusShutdown GDIP
    End If
  End If
End Sub

Public Sub LoadFromSprite(Src As SR2D_Sprite, Optional ByVal Trans As SR2D_Transform = TrNone, Optional ByVal W As Long = 0, Optional ByVal h As Long = 0, Optional ByVal cKey As Long = -1)
  Dim fResize As Boolean, Ar() As Long, d As Long

  If W <= 0 Then W = Src.Width Else If W <> Src.Width Then fResize = True
  If h <= 0 Then h = Src.Height Else If h <> Src.Height Then fResize = True
  If fResize Then
    Init W, h, Src.Op
    If Trans = TrNone Then
      SResize Src.DataPTR(0, 0), DataPTR(0, 0), Src.Width, Src.Height, meWidth, meHeight
    ElseIf W * h > Src.Width * Src.Height Then
      ReDim Ar(Src.Width * Src.Height - 1)
      W = Src.Width: h = Src.Height
      Transform Src.DataPTR(0, 0), VarPtr(Ar(0)), W, h, Trans
      If Trans > TrFlipXY Then d = W: W = h: h = d
      SResize VarPtr(Ar(0)), VarPtr(cBuf(0)), W, h, meWidth, meHeight
    Else
      ReDim Ar(W * h - 1)
      If Trans > TrFlipXY Then d = W: W = h: h = d
      SResize Src.DataPTR(0, 0), VarPtr(Ar(0)), Src.Width, Src.Height, W, h
      Transform VarPtr(Ar(0)), VarPtr(cBuf(0)), W, h, Trans
    End If
  Else
    If Trans > TrFlipXY Then d = W: W = h: h = d
    Init W, h, Src.Op
    Transform Src.DataPTR(0, 0), VarPtr(cBuf(0)), Src.Width, Src.Height, Trans
  End If
  If cKey >= 0 Then AddColorKey cKey: Op = OpAlphaTest
End Sub

Public Sub SaveToFile(fName As String, ByVal fFormat As SR2D_FileFormat, Optional ByVal JPGQuality As Long = 80)
  Dim tSI As GdiplusStartupInput
  Dim Res As Long
  Dim GDIP As Long
  Dim Bmp As Long
  Dim tEncoder As CLSID
  Dim tParams As EncoderParameters
  Dim sType As String
  Dim ArRGB() As Byte
  Dim Stride As Long

  tSI.GdiplusVersion = 1
  Res = GdiplusStartup(GDIP, tSI)
  If Res = 0 Then
    If fFormat = FF_ARGB_BMP Or fFormat = FF_ARGB_PNG Or fFormat = FF_RGB_JPG Then
      Res = GdipCreateBitmapFromScan0(Width, Height, Width * 4, PixelFormat32bppARGB, cBuf(0), Bmp)
    Else
      Stride = ((Width * 3 - 1) Or 3) + 1
      ReDim ArRGB(Stride * Height - 1)
      Bpp32to24 cBuf(0), ArRGB(0), Width, Height, Stride
      Res = GdipCreateBitmapFromScan0(Width, Height, Stride, PixelFormat24bppRGB, ArRGB(0), Bmp)
    End If
    If Res = 0 Then
      Select Case fFormat
        Case FF_ARGB_BMP, FF_RGB_BMP
          sType = "{557CF400-1A04-11D3-9A73-0000F81EF32E}"
        Case FF_ARGB_PNG, FF_RGB_PNG
          sType = "{557CF406-1A04-11D3-9A73-0000F81EF32E}"
        Case FF_RGB_JPG
          sType = "{557CF401-1A04-11D3-9A73-0000F81EF32E}"
          tParams.count = 1
          tParams.Parameter.NumberOfValues = 1
          tParams.Parameter.type = 4
          tParams.Parameter.value = VarPtr(JPGQuality)
          CLSIDFromString StrPtr("{1D5BE4B5-FA4A-452D-9CDD-5DB35105E7EB}"), tParams.Parameter.GUID
      End Select
      CLSIDFromString StrPtr(sType), tEncoder
      If tParams.count = 0 Then
        Res = GdipSaveImageToFile(Bmp, StrPtr(fName), tEncoder, ByVal 0)
      Else
        Res = GdipSaveImageToFile(Bmp, StrPtr(fName), tEncoder, tParams)
      End If
      GdipDisposeImage Bmp
    End If
    GdiplusShutdown GDIP
  End If
End Sub

Private Sub Transform(ByVal pSrc As Long, ByVal pDest As Long, ByVal W As Long, ByVal h As Long, ByVal Trans As SR2D_Transform)
  Select Case Trans
    Case TrFlipX
      SFlipX pSrc, pDest, W, h
    Case TrFlipY
      SFlipY pSrc, pDest, W, h
    Case TrFlipXY
      SFlipXY pSrc, pDest, W, h
    Case TrRotCCW
      SRotCCW pSrc, pDest, W, h
    Case TrRotCW
      SRotCW pSrc, pDest, W, h
    Case TrFlipXRotCCW
      SFlipXRotCCW pSrc, pDest, W, h
    Case TrFlipYRotCCW
      SFlipYRotCCW pSrc, pDest, W, h
    Case Else
      CopyMemory ByVal pSrc, ByVal pDest, W * h * 4
  End Select
End Sub

Public Sub SetLockRect(Optional ByVal Left As Long = -1, Optional ByVal Right As Long = -1, Optional ByVal Top As Long = -1, Optional ByVal Bottom As Long = -1)
  If Left >= 0 And Left < meWidth Then meLeft = Left Else meLeft = 0
  If Right > Left And Right <= meWidth Then meRight = Right Else meRight = meWidth
  If Top >= 0 And Top < meHeight Then meTop = Top Else meTop = 0
  If Bottom > Top And Bottom <= meHeight Then meBottom = Bottom Else meBottom = meHeight
End Sub

Public Property Get Width() As Long
  Width = meWidth
End Property

Public Property Get Height() As Long
  Height = meHeight
End Property

Public Property Let Op(ByVal Op As SR2D_Op)
  If Op <> OpDefault Then meOp = Op
End Property

Public Property Get Op() As SR2D_Op
  Op = meOp
End Property

Public Property Let BlendFactor(ByVal f As Long)
  meBFactor = f
End Property

Public Property Get BlendFactor() As Long
  BlendFactor = meBFactor
End Property

Public Property Get DataPTR(ByVal x As Long, ByVal y As Long) As Long
  DataPTR = VarPtr(cBuf(x + y * meWidth))
End Property

Public Sub PaintToDevice(ByVal hdc As Long)
  SetDIBitsToDevice hdc, 0, 0, meWidth, meHeight, 0, 0, 0, meHeight, cBuf(0), bi32BitInfo, 0
End Sub

Public Sub AddColorKey(ByVal cKey As Long)
  SAddColorKey cBuf(0), meWidth, meHeight, cKey
End Sub

Public Sub SetPixel(ByVal x As Long, ByVal y As Long, ByVal c As Long)
  If x < meLeft Then Exit Sub
  If x >= meRight Then Exit Sub
  If y < meTop Then Exit Sub
  If y >= meBottom Then Exit Sub
  cBuf(x + y * meWidth) = c
End Sub

Public Function GetPixel(ByVal x As Long, ByVal y As Long) As Long
  If x < 0 Then Exit Function
  If x >= meWidth Then Exit Function
  If y < 0 Then Exit Function
  If y >= meHeight Then Exit Function
  GetPixel = cBuf(x + y * meWidth)
End Function

Private Sub Class_Initialize()
  Init 0, 0, OpPaint
End Sub

Private Function ColFromLite(ByVal x As Long, ByVal y As Long, ByVal Z As Long, ByVal Brite As Single) As Long
  Dim R As Long, G As Long, B As Long
  Dim k As Single

  If Brite < 0 Then Brite = 0
  If Brite > 1 Then Brite = 1
  k = 127.4999 * Brite / Sqr(x * x + y * y + Z * Z)

  R = x * k: R = R + 128
  G = y * k: G = G + 128
  B = Z * k: B = B + 128

  ColFromLite = R * &H10000 + G * &H100 + B
End Function
